Debian Bug report logs - #471067
libwww-perl: no IPv6 support

Package: libnet-http-perl; Maintainer for libnet-http-perl is Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>; Source for libnet-http-perl is src:libnet-http-perl.

Reported by: Peter Eisentraut <peter_e@gmx.net>

Date: Sat, 15 Mar 2008 12:12:03 UTC

Owned by: nicholas@periapt.co.uk

Severity: important

Tags: ipv6, jessie, sid, squeeze, upstream, wheezy

Merged with 306914

Forwarded to https://rt.cpan.org/Ticket/Display.html?id=29468

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Brendan O'Dea <bod@debian.org>:
Bug#471036; Package perl. Full text and rfc822 format available.

Acknowledgement sent to Peter Eisentraut <peter_e@gmx.net>:
New Bug report received and forwarded. Copy sent to Brendan O'Dea <bod@debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Peter Eisentraut <peter_e@gmx.net>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: problems with IPv6
Date: Sat, 15 Mar 2008 13:10:45 +0100
Package: perl
Version: 5.8.8-12
Severity: normal
Tags: ipv6

I have set "options inet6" set in /etc/resolv.conf, and all the sudden a few
Perl programs started segfaulting.  It is most easily reproducible with uscan.
(debrelease is another example.)

Using this debian/watch:

version=3
http://ftp.ggzgamingzone.org/pub/ggz/([0-9.]+)/ggz-grubby-([0-9.]+).tar.gz

and this debian/changelog:

ggz-grubby (0.0.14-3) UNRELEASED; urgency=low

  * Added homepage and x-vcs fields to debian/control

 -- Josef Spillner <josef@ggzgamingzone.org>  Fri, 30 Nov 2007 19:18:51 +0100

I get this:

$ uscan
-- Scanning for watchfiles in .
-- Found watchfile in ./debian
-- In debian/watch, processing watchfile line:
   http://ftp.ggzgamingzone.org/pub/ggz/([0-9.]+)/ggz-grubby-([0-9.]+).tar.gz
zsh: segmentation fault (core dumped)  uscan

If I delete "options inet6", it works.

-- System Information:
Debian Release: lenny/sid
  APT prefers testing
  APT policy: (990, 'testing'), (500, 'unstable'), (500, 'stable'), (1, 'experimental')
Architecture: i386 (i686)

Kernel: Linux 2.6.24-1-686 (SMP w/1 CPU core)
Locale: LANG=de_DE.utf8, LC_CTYPE=de_DE.utf8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages perl depends on:
ii  libc6                         2.7-6      GNU C Library: Shared libraries
ii  libdb4.6                      4.6.21-6   Berkeley v4.6 Database Libraries [
ii  libgdbm3                      1.8.3-3    GNU dbm database routines (runtime
ii  perl-base                     5.8.8-12   The Pathologically Eclectic Rubbis
ii  perl-modules                  5.8.8-12   Core Perl modules

Versions of packages perl recommends:
ii  perl-doc                      5.8.8-12   Perl documentation

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Brendan O'Dea <bod@debian.org>:
Bug#471036; Package perl. Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. Copy sent to Brendan O'Dea <bod@debian.org>. Full text and rfc822 format available.

Message #10 received at 471036@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: Peter Eisentraut <peter_e@gmx.net>, 471036@bugs.debian.org
Subject: Re: Bug#471036: problems with IPv6
Date: Sat, 15 Mar 2008 18:42:00 +0200
clone 471036 -1
reassign -1 libwww-perl 5.808-1
retitle -1 libwww-perl: no IPv6 support
forwarded -1 http://rt.cpan.org/Public/Bug/Display.html?id=29468
thanks

On Sat, Mar 15, 2008 at 01:10:45PM +0100, Peter Eisentraut wrote:
> Package: perl
> Version: 5.8.8-12
> Severity: normal
> Tags: ipv6
> 
> I have set "options inet6" set in /etc/resolv.conf, and all the sudden a few
> Perl programs started segfaulting.  It is most easily reproducible with uscan.
> (debrelease is another example.)

First, uscan uses LWP, which doesn't support ipv6. It always uses
IO::Socket::INET, and bad things happen when it gets an IPv6 address to
connect to. I'm cloning a new bug against libwww-perl for this.

The Perl core side of this boils down to something like

perl -MSocket -e 'socket($s, PF_INET, SOCK_STREAM, 6) or die "socket: $!"; connect($s, sockaddr_in(80,inet_aton("ftp.fi.debian.org"))) or die "connect: $!";'

which crashes on i386 (but not on amd64) with Perl 5.8.8 when 
"options inet6" is set in /etc/resolv.conf.

On amd64 it doesn't crash but instead takes the low four octets of the
IPv6 address and uses them as an IPv4 one:

 connect(3, {sa_family=AF_INET, sin_port=htons(80), sin_addr=inet_addr("32.1.7.8")}, 16 <unfinished ...>

This is fixed in Perl 5.10.0, where inet_ntoa() returns undef with
"options inet6", and sockaddr_in() is better prepared for that:

 Bad arg length for Socket::pack_sockaddr_in, length is 0, should be 4 at /usr/lib/perl/5.10/Socket.pm line 214.

From the changelog:

[ 31138] By: rgs                                   on 2007/05/04  14:02:26
        Log: Subject: [perl #42844] careless use of gethostbyname() in Socket.xs 
             From: kan@dcit.cz (via RT) <perlbug-followup@perl.org>
             Date: Tue, 01 May 2007 09:17:22 -0700
             Message-ID: <rt-3.6.HEAD-6655-1178036242-364.42844-75-0@perl.org>
     Branch: perl
           ! ext/Socket/Socket.pm ext/Socket/Socket.xs

I'd suggest closing this at 5.10.0-1, but will leave that to the maintainer.

Cheers,
-- 
Niko Tyni   ntyni@debian.org




Bug 471036 cloned as bug 471067. Request was from Niko Tyni <ntyni@debian.org> to control@bugs.debian.org. (Sat, 15 Mar 2008 16:45:05 GMT) Full text and rfc822 format available.

Bug reassigned from package `perl' to `libwww-perl'. Request was from Niko Tyni <ntyni@debian.org> to control@bugs.debian.org. (Sat, 15 Mar 2008 16:45:08 GMT) Full text and rfc822 format available.

Changed Bug title to `libwww-perl: no IPv6 support' from `problems with IPv6'. Request was from Niko Tyni <ntyni@debian.org> to control@bugs.debian.org. (Sat, 15 Mar 2008 16:45:09 GMT) Full text and rfc822 format available.

Noted your statement that Bug has been forwarded to http://rt.cpan.org/Public/Bug/Display.html?id=29468. Request was from Niko Tyni <ntyni@debian.org> to control@bugs.debian.org. (Sat, 15 Mar 2008 16:45:10 GMT) Full text and rfc822 format available.

Tags added: upstream Request was from Peter Eisentraut <peter_e@gmx.net> to control@bugs.debian.org. (Thu, 03 Apr 2008 15:33:11 GMT) Full text and rfc822 format available.

Merged 306914 471067. Request was from Antonio Radici <antonio@dyne.org> to control@bugs.debian.org. (Sat, 28 Feb 2009 12:12:10 GMT) Full text and rfc822 format available.

Severity set to 'serious' from 'normal' Request was from Clint Adams <schizo@debian.org> to control@bugs.debian.org. (Tue, 23 Mar 2010 01:04:00 GMT) Full text and rfc822 format available.

Added tag(s) sid and squeeze. Request was from Gerfried Fuchs <rhonda@debian.at> to control@bugs.debian.org. (Tue, 23 Mar 2010 07:51:37 GMT) Full text and rfc822 format available.

Severity set to 'normal' from 'serious' Request was from Gerfried Fuchs <rhonda@deb.at> to control@bugs.debian.org. (Tue, 23 Mar 2010 08:31:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, baryluk@smp.if.uj.edu.pl, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#471067; Package libwww-perl. (Thu, 01 Apr 2010 02:18:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Witold Baryluk <baryluk@smp.if.uj.edu.pl>:
Extra info received and forwarded to list. Copy sent to baryluk@smp.if.uj.edu.pl, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Thu, 01 Apr 2010 02:18:03 GMT) Full text and rfc822 format available.

Message #33 received at 471067@bugs.debian.org (full text, mbox):

From: Witold Baryluk <baryluk@smp.if.uj.edu.pl>
To: Debian Bug Tracking System <471067@bugs.debian.org>
Subject: Re: It also doesn't work with IPv6 HTTP proxy (i.e. POST command)
Date: Thu, 01 Apr 2010 04:14:07 +0200
Package: libwww-perl
Version: 5.834-1
Severity: normal

I have env.var. http_proxy=http://localhost:8118, and my /etc/hosts contain ::1
for localhost, and proxy (privoxy) is listening ONLY on [::1]:8118. POST fails
in such situation, with "500 Can't connct to localhost:8118 (Bad hostname
'localhost')." (resolver fails), when i have "options inet6", or "500 Can't
connect to localhost:8118 (connect: Połączenie odrzucone)" (it is using IPv4
addres, where no service is running) without "options inet6".  Other programs
works (wget,curl,opera,epiphany-browser,reportbug). Sorry for lack of new lines
(bug in reportbug).


-- System Information:
Debian Release: squeeze/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: i386 (i686)

Kernel: Linux 2.6.34-rc2-sredniczarny-00184-g01e7770 (PREEMPT)
Locale: LANG=pl_PL.UTF-8, LC_CTYPE=pl_PL.UTF-8 (charmap=UTF-8) (ignored: LC_ALL set to pl_PL.UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages libwww-perl depends on:
ii  libhtml-parser-perl           3.64-1     collection of modules that parse H
ii  libhtml-tagset-perl           3.20-2     Data tables pertaining to HTML
ii  libhtml-tree-perl             3.23-2     Perl module to represent and creat
ii  liburi-perl                   1.53-1     module to manipulate and access UR
ii  netbase                       4.40       Basic TCP/IP networking system
ii  perl                          5.10.1-11  Larry Wall's Practical Extraction 

Versions of packages libwww-perl recommends:
ii  libhtml-format-perl           2.04-2     format HTML syntax trees into text
ii  libmailtools-perl             2.06-1     Manipulate email in perl programs
ii  perl [libio-compress-perl]    5.10.1-11  Larry Wall's Practical Extraction 

Versions of packages libwww-perl suggests:
ii  libcrypt-ssleay-perl          0.57-2     Support for https protocol in LWP
ii  libio-socket-ssl-perl         1.33-1     Perl module implementing object or

-- no debconf information




Added tag(s) wheezy. Request was from Kurt Roeckx <kurt@roeckx.be> to control@bugs.debian.org. (Wed, 16 Feb 2011 19:03:07 GMT) Full text and rfc822 format available.

Forcibly Merged 306914 471067 614948. Request was from gregor herrmann <gregoa@debian.org> to control@bugs.debian.org. (Thu, 24 Feb 2011 13:48:04 GMT) Full text and rfc822 format available.

Set Bug forwarded-to-address to 'http://rt.cpan.org/Public/Bug/Display.html?id=29468'. Request was from gregor herrmann <gregoa@debian.org> to control@bugs.debian.org. (Thu, 24 Feb 2011 13:48:08 GMT) Full text and rfc822 format available.

Changed Bug forwarded-to-address to 'https://rt.cpan.org/Ticket/Display.html?id=29468' from 'http://rt.cpan.org/Public/Bug/Display.html?id=29468' Request was from Maximilian Gass <maximilian.gass@credativ.de> to control@bugs.debian.org. (Thu, 24 Feb 2011 14:27:09 GMT) Full text and rfc822 format available.

Severity set to 'important' from 'serious' Request was from Ansgar Burchardt <ansgar@debian.org> to control@bugs.debian.org. (Mon, 14 Mar 2011 20:03:04 GMT) Full text and rfc822 format available.

Owner recorded as nicholas@periapt.co.uk. Request was from Nicholas Bamber <nicholas@periapt.co.uk> to control@bugs.debian.org. (Mon, 14 Mar 2011 22:21:16 GMT) Full text and rfc822 format available.

Bug reassigned from package 'libwww-perl' to 'libnet-http-perl'. Request was from Nicholas Bamber <nicholas@periapt.co.uk> to control@bugs.debian.org. (Thu, 17 Mar 2011 20:15:07 GMT) Full text and rfc822 format available.

Bug No longer marked as found in versions libwww-perl/5.834-1, libwww-perl/5.808-1, and libwww-perl/5.837-1. Request was from Nicholas Bamber <nicholas@periapt.co.uk> to control@bugs.debian.org. (Thu, 17 Mar 2011 20:15:08 GMT) Full text and rfc822 format available.

Disconnected #614948 from all other report(s). Request was from Nicholas Bamber <nicholas@periapt.co.uk> to control@bugs.debian.org. (Thu, 17 Mar 2011 20:24:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, nicholas@periapt.co.uk:
Bug#471067; Package libnet-http-perl. (Thu, 17 Mar 2011 23:48:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Nicholas Bamber <nicholas@periapt.co.uk>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, nicholas@periapt.co.uk. (Thu, 17 Mar 2011 23:48:03 GMT) Full text and rfc822 format available.

Message #56 received at 471067@bugs.debian.org (full text, mbox):

From: Nicholas Bamber <nicholas@periapt.co.uk>
To: 471067@bugs.debian.org
Subject: Future plans in core
Date: Thu, 17 Mar 2011 23:45:42 +0000
Note this: 
http://www.nntp.perl.org/group/perl.perl5.porters/2010/12/msg166955.html




Added indication that 471067 affects libwww-perl Request was from gregor herrmann <gregoa@debian.org> to control@bugs.debian.org. (Mon, 02 May 2011 20:30:02 GMT) Full text and rfc822 format available.

Added tag(s) jessie. Request was from Julien Cristau <jcristau@debian.org> to control@bugs.debian.org. (Thu, 18 Apr 2013 17:38:25 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 02:12:49 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.